Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.essbase.api.metadata
Interface IEssCubeOutline

All Superinterfaces:
  IEssBaseObject, IEssExtendedObject, IEssProperties

public interface IEssCubeOutline
extends IEssExtendedObject, IEssProperties

The IEssCubeOutline is the cube outline.

Nested Class Summary

Nested classes inherited from class com.essbase.api.base.IEssProperties
`IEssProperties.EEssPropertyMode`

Field Summary
`static int` | `PROP_ALIAS_TABLE_NAMES`
`static int` | `PROP_AUTO_CONFIGURE`
`static int` | `PROP_CASE_SENSITIVE`
`static int` | `PROP_COUNT_ALIAS_TABLES`
`static int` | `PROP_NAME`
`static int` | `PROP_OUTLINE_TYPE`
`static int` | `s_countProperties`
`static IEssValueAny.EEssDataType[]` | `s_propDataTypes`
`static IEssProperties.EEssPropertyMode[]` | `s_propModes`
`static java.lang.String[]` | `s_propNames`

Method Summary
`void` | `associateAttributeDimension(IEssDimension standardDim, IEssDimension attributeDim)` Associates an attribute dimension with a base dimension.
`void` | `associateAttributeMember(IEssMember standardMbr, IEssMember attributeMbr)` Associates an attribute member with a base member.
`void` | `associateAttributeMember(java.lang.String standardMbrName, java.lang.String attributeMbrName)` Associates an attribute member with a base member.
`void` | `clearAliasTable(java.lang.String aliasTableName)` Clears all entries from an existing alias table without deleting the alias table
`void` | `close()` Closes the outline freeing all resources associated with the outline.
`void` | `close(boolean ignoreErrors)` Closes the outline freeing all resources associated with the outline.
`void` | `copyAliasTable(java.lang.String srcAliasTableName, java.lang.String destAliasTableName, boolean merge)` Copies an alias table to another alias table.
`void` | `create(boolean caseSensitive, IEssCube.EEssCubeType outlineType, boolean autoConfigure)` Creates a new outline.
`void` | `createAliasTable(java.lang.String aliasTableName)` Creates an empty alias table in the outline.
`IEssDimension` | `createAttributeDimension(java.lang.String dimName, IEssDimension.EEssAttributeDataType attrDataType, IEssDimension prevSibling)` Creates an attribute dimension.
`IEssDimension` | `createDimension(java.lang.String dimName)` Creates a dimension.
`IEssDimension` | `createDimension(java.lang.String dimName, IEssDimension prevSibling)` Creates a dimension.
`void` | `deleteAliasTable(java.lang.String aliasTableName)` Deletes the alias table from the outline and clears all of its entries.
`void` | `deleteDTSMemberAlias(java.lang.String dtsMemberName, java.lang.String aliasTableName)` Deletes an alias name for a Dynamic Time Series member.
`void` | `disassociateAttributeDimension(IEssDimension standardDim, IEssDimension attributeDim)` Disassociates an attribute dimension from a base dimension.
`void` | `disassociateAttributeMember(IEssMember standardMbr, IEssMember attributeMbr)` Disassociates an attribute member from a base member
`void` | `enableDTSMember(java.lang.String dtsMemberName, int genNum, boolean enable)` Enables a new Dynamic Time Series members for the outline.
`IEssIterator` | `executeQuery(java.lang.String mbrName, int queryType, int queryOptions, java.lang.String dimName, java.lang.String input1, java.lang.String input2)` Member selection over outline.
`IEssIterator` | `executeQuery(java.lang.String fieldSelection, java.lang.String mbrSelection)` Member selection over outline.
`IEssMember` | `findAlias(java.lang.String aliasName, java.lang.String aliasTableName)` Finds a member for the alias name.
`IEssIterator` | `findAttributeMembers(java.lang.String attShortName, java.lang.String dimName)` Gets all the attribute members having the specified short name.
`IEssDimension` | `findDimension(java.lang.String mbrName)` Finds a dimension for the member.
`IEssMember` | `findMember(java.lang.String mbrName)` Finds a member.
`IEssIterator` | `findMembers(java.lang.String[] mbrNames)` Finds members.
`IEssCubeOutline` | `generateCurrencyOutline()` Generates a currency outline based on the current (source) outline.
`java.lang.String[]` | `getAliasTableNames()` Gets the names of alias tables existing in the outline.
`int` | `getBucketingType()` Gets the numeric attribute's bucketing type.
`int` | `getCountAliasTables()` Gets the count of alias tables existing in the outline.
`int` | `getCountEnabledDTSMembers()` Gets the count of defined DTS members for the outline.
`IEssCube` | `getCube()` Gets the parent cube.
`int` | `getDateFormat()` Gets the format for a datetime attribute.
`java.lang.String` | `getDefaultAttrCalcDimName()` Gets the name of the attribute calculations (aggregate) dimension.
`java.lang.String` | `getDefaultAverageMbrName()` Gets the name used with the attribute calculations (aggregate) dimension to indicate AVERAGE.
`java.lang.String` | `getDefaultCountMbrName()` Gets the name used with the attribute calculations (aggregate) dimension to indicate COUNT.
`java.lang.String` | `getDefaultFalseString()` Gets the string used with the boolean attribute to indicate false.
`java.lang.String` | `getDefaultMaxMbrName()` Gets the name used with the attribute calculations (aggregate) dimension to indicate MAXIMUM.
`java.lang.String` | `getDefaultMinMbrName()` Gets the name used with the attribute calculations (aggregate) dimension to indicate MINIMUM.
`java.lang.String` | `getDefaultSumMbrName()` Gets the name used with the attribute calculations (aggregate) dimension to indicate SUM.
`java.lang.String` | `getDefaultTrueString()` Gets the string used with the boolean attribute to indicate true.
`int` | `getDelimiter()` Gets the delimiter to use when generating a long name.
`IEssIterator` | `getDimensions()` Gets the list of dimensions.
`java.lang.String` | `getDTSMemberAlias(java.lang.String dtsMemberName, java.lang.String aliasTableName)` Gets an alias name for a Dynamic Time Series member.
`java.lang.String` | `getEnabledDTSMember(int index)` Gets the defined DTS member name for the outline at the specified index.
`int` | `getGenerationForEnabledDTSMember(int index)` Gets the generation for the defined DTS member name for the outline at the specified index.
`IEssCube.EEssCubeType` | `getOutlineType()` Gets the outline type.
`IEssIterator` | `getSharedMembers(java.lang.String mbrName)` Gets all the shared members of the specified member.
`java.util.Date` | `getUpdateTime()` Gets a timestamp for this outline.
`int` | `getUseNameOf()` Gets which generation(s) of the zero-level member to use when generating a long name.
`boolean` | `isAutoConfigure()` Checks if to automatically configure the dimension storage(dense/sparse) when the outline is saved.
`boolean` | `isCaseSensitive()` Checks if the member names are case-sensitive.
`boolean` | `isGenerationNameByPrefix()` Checks if to use the generation(s) of the zero-level member as the prefix or the suffix when generating a long name.
`boolean` | `isOpen()` Checks if the outline is open.
`void` | `moveMember(IEssMember mbrToMove, IEssMember newParent, IEssMember newPrevSibling)` Moves a member.
`void` | `open()` Opens the cube outline in read-only mode.
`void` | `open(boolean readOnly, boolean lock, boolean keepTrans)` Opens the cube outline in read-only or read-write mode.
`void` | `refreshPropertyValues()` Refreshes the property values.
`void` | `renameAliasTable(java.lang.String aliasTableName, java.lang.String newAliasTableName)` Renames an existing alias table
`void` | `restructureCube(IEssCube.EEssRestructureOption restructOption)` Restructures the cube based on the newly saved outline.
`void` | `save()` Writes the existing outline information to disk.
`void` | `save(IEssCube.EEssRestructureOption restructOption)` Performs 3 operations in one shot: 1.
`void` | `setAutoConfigure(boolean autoConfigure)` Sets if to automatically configure the dimension storage(dense/sparse) when the outline is saved.
`void` | `setBucketingType(int bucketingType)` Sets the numeric attribute's bucketing type.
`void` | `setCaseSensitive(boolean caseSensitive)` Sets if the member names are case-sensitive.
`void` | `setDateFormat(int dateFormat)` Sets the format for a datetime attribute.
`void` | `setDefaultAttrCalcDimName(java.lang.String defAttrCalcDimName)` Sets the name of the attribute calculations (aggregate) dimension.
`void` | `setDefaultAverageMbrName(java.lang.String defAverageMbrName)` Sets the name used with the attribute calculations (aggregate) dimension to indicate AVERAGE.
`void` | `setDefaultCountMbrName(java.lang.String defCountMbrName)` Sets the name used with the attribute calculations (aggregate) dimension to indicate COUNT.
`void` | `setDefaultFalseString(java.lang.String defFalseString)` Sets the string used with the boolean attribute to indicate false.
`void` | `setDefaultMaxMbrName(java.lang.String defMaxMbrName)` Sets the name used with the attribute calculations (aggregate) dimension to indicate MAXIMUM.
`void` | `setDefaultMinMbrName(java.lang.String defMinMbrName)` Sets the name used with the attribute calculations (aggregate) dimension to indicate MINIMUM.
`void` | `setDefaultSumMbrName(java.lang.String defSumMbrName)` Sets the name used with the attribute calculations (aggregate) dimension to indicate SUM.
`void` | `setDefaultTrueString(java.lang.String defTrueString)` Sets the string used with the boolean attribute to indicate true.
`void` | `setDelimiter(int delimiter)` Sets the delimiter to use when generating a long name.
`void` | `setDTSMemberAlias(java.lang.String dtsMemberName, java.lang.String aliasTableName, java.lang.String alias)` Sets an alias name for a Dynamic Time Series member.
`void` | `setGenerationNameByPrefix(boolean genNameByPrefix)` Sets if to use the generation(s) of the zero-level member as the prefix or the suffix when generating a long name.
`void` | `setOutlineType(IEssCube.EEssCubeType otlType)` Sets the outline type.
`void` | `setUseNameOf(int whichGen)` Sets which generation(s) of the zero-level member to use when generating a long name.
`void` | `updatePropertyValues()` Updates the property values.
`void` | `verify()` Verifies the outline for correctness.

Methods inherited from interface com.essbase.api.base.IEssExtendedObject
`clearClientCache, getName, getParent, getParentBase, isClientCachingEnabled, setClientCachingEnabled`

Methods inherited from interface com.essbase.api.base.IEssProperties
`getCountProperties, getPropertyDataType, getPropertyDataType, getPropertyDataTypes, getPropertyId, getPropertyMode, getPropertyMode, getPropertyModes, getPropertyName, getPropertyNames, getPropertyValueAny, getPropertyValueAny, setPropertyValueAny, setPropertyValueAny`

Field Detail

### PROP_NAME

    public static final int PROP_NAME

See Also:
  Constant Field Values

### PROP_CASE_SENSITIVE

    public static final int PROP_CASE_SENSITIVE

See Also:
  Constant Field Values

### PROP_OUTLINE_TYPE

    public static final int PROP_OUTLINE_TYPE

See Also:
  Constant Field Values

### PROP_AUTO_CONFIGURE

    public static final int PROP_AUTO_CONFIGURE

See Also:
  Constant Field Values

### PROP_COUNT_ALIAS_TABLES

    public static final int PROP_COUNT_ALIAS_TABLES

See Also:
  Constant Field Values

### PROP_ALIAS_TABLE_NAMES

    public static final int PROP_ALIAS_TABLE_NAMES

See Also:
  Constant Field Values

### s_countProperties

    public static final int s_countProperties

See Also:
  Constant Field Values

### s_propNames

    public static final java.lang.String[] s_propNames

### s_propDataTypes

    public static final IEssValueAny.EEssDataType[] s_propDataTypes

### s_propModes

    public static final IEssProperties.EEssPropertyMode[] s_propModes

Method Detail

### isCaseSensitive

    public boolean isCaseSensitive()
                            throws EssException

  Checks if the member names are case-sensitive.

  Returns:
    true if the member names are case-sensitive.
  Throws:
    `EssException` - if an error occurs.

### setCaseSensitive

    public void setCaseSensitive(boolean caseSensitive)
                          throws EssException

  Sets if the member names are case-sensitive. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `caseSensitive` - true if the member names are case-sensitive.
  Throws:
    `EssException` - if an error occurs.

### getOutlineType

    public IEssCube.EEssCubeType getOutlineType()
                                         throws EssException

  Gets the outline type.

  Returns:
    The outline type.
  Throws:
    `EssException` - if an error occurs.

### setOutlineType

    public void setOutlineType(IEssCube.EEssCubeType otlType)
                        throws EssException

  Sets the outline type. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `otlType` - The outline type.
  Throws:
    `EssException` - if an error occurs.

### isAutoConfigure

    public boolean isAutoConfigure()
                            throws EssException

  Checks if to automatically configure the dimension storage(dense/sparse) when the outline is saved.

  Returns:
    true to auto configure.
  Throws:
    `EssException` - if an error occurs.

### setAutoConfigure

    public void setAutoConfigure(boolean autoConfigure)
                          throws EssException

  Sets if to automatically configure the dimension storage(dense/sparse) when the outline is saved. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `autoConfigure` - true to auto configure.
  Throws:
    `EssException` - if an error occurs.

### getCountAliasTables

    public int getCountAliasTables()
                            throws EssException

  Gets the count of alias tables existing in the outline.

  Returns:
    The count of alias tables.
  Throws:
    `EssException` - if an error occurs.

### getAliasTableNames

    public java.lang.String[] getAliasTableNames()
                                          throws EssException

  Gets the names of alias tables existing in the outline.

  Returns:
    The alias table names.
  Throws:
    `EssException` - if an error occurs.

### isGenerationNameByPrefix

    public boolean isGenerationNameByPrefix()
                                     throws EssException

  Checks if to use the generation(s) of the zero-level member as the prefix or the suffix when generating a long name. This is an attribute specification for the outline. The default value is true.

  Returns:
    true to use generation name by prefix.
  Throws:
    `EssException` - if an error occurs.

### setGenerationNameByPrefix

    public void setGenerationNameByPrefix(boolean genNameByPrefix)
                                   throws EssException

  Sets if to use the generation(s) of the zero-level member as the prefix or the suffix when generating a long name. This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `genNameByPrefix` - true to use generation name by prefix.
  Throws:
    `EssException` - if an error occurs.

### getUseNameOf

    public int getUseNameOf()
                     throws EssException

  Gets which generation(s) of the zero-level member to use when generating a long name. This is an attribute specification for the outline.

  Returns:
    0 for none (default), 1 for parent, 2 for grand parent and parent, 3 for all ancestors, 4 for dimension.
  Throws:
    `EssException` - if an error occurs.

### setUseNameOf

    public void setUseNameOf(int whichGen)
                      throws EssException

  Sets which generation(s) of the zero-level member to use when generating a long name. This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `whichGen` - 0 for none (default), 1 for parent, 2 for grand parent and parent, 3 for all ancestors, 4 for dimension.
  Throws:
    `EssException` - if an error occurs.

### getDelimiter

    public int getDelimiter()
                     throws EssException

  Gets the delimiter to use when generating a long name. This is an attribute specification for the outline.

  Returns:
    0 for underscore (default), 1 for pipe, 2 for caret.
  Throws:
    `EssException` - if an error occurs.

### setDelimiter

    public void setDelimiter(int delimiter)
                      throws EssException

  Sets the delimiter to use when generating a long name. This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `delimiter` - 0 for underscore (default), 1 for pipe, 2 for caret.
  Throws:
    `EssException` - if an error occurs.

### getDateFormat

    public int getDateFormat()
                      throws EssException

  Gets the format for a datetime attribute. This is an attribute specification for the outline.

  Returns:
    0 for MMDDYYYY (default), 1 for DDMMYY.
  Throws:
    `EssException` - if an error occurs.

### setDateFormat

    public void setDateFormat(int dateFormat)
                       throws EssException

  Sets the format for a datetime attribute. This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `dateFormat` - 0 for MMDDYYYY (default), 1 for DDMMYY.
  Throws:
    `EssException` - if an error occurs.

### getBucketingType

    public int getBucketingType()
                         throws EssException

  Gets the numeric attribute's bucketing type. This is an attribute specification for the outline.

  Returns:
    0 for upper bound inclusive (default), 1 for lower bound inclusive, 2 for upper bound non inclusive, 3 for lower bound non inclusive.
  Throws:
    `EssException` - if an error occurs.

### setBucketingType

    public void setBucketingType(int bucketingType)
                          throws EssException

  Sets the numeric attribute's bucketing type. This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `bucketingType` - 0 for upper bound inclusive (default), 1 for lower bound inclusive, 2 for upper bound non inclusive, 3 for lower bound non inclusive.
  Throws:
    `EssException` - if an error occurs.

### getDefaultTrueString

    public java.lang.String getDefaultTrueString()
                                          throws EssException

  Gets the string used with the boolean attribute to indicate true. This is an attribute specification for the outline.

  Returns:
    The string used to indicate true. Default value is "True".
  Throws:
    `EssException` - if an error occurs.

### setDefaultTrueString

    public void setDefaultTrueString(java.lang.String defTrueString)
                              throws EssException

  Sets the string used with the boolean attribute to indicate true. This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `defTrueString` - The default true string.
  Throws:
    `EssException` - if an error occurs.

### getDefaultFalseString

    public java.lang.String getDefaultFalseString()
                                           throws EssException

  Gets the string used with the boolean attribute to indicate false. This is an attribute specification for the outline.

  Returns:
    The string used to indicate false. Default value is "False".
  Throws:
    `EssException` - if an error occurs.

### setDefaultFalseString

    public void setDefaultFalseString(java.lang.String defFalseString)
                               throws EssException

  Sets the string used with the boolean attribute to indicate false. This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `defFalseString` - The default false string.
  Throws:
    `EssException` - if an error occurs.

### getDefaultAttrCalcDimName

    public java.lang.String getDefaultAttrCalcDimName()
                                               throws EssException

  Gets the name of the attribute calculations (aggregate) dimension. The default value is "Attribute Calculations". This is an attribute specification for the outline.

  Returns:
    The default attribute calculation dimension name.
  Throws:
    `EssException` - if an error occurs.

### setDefaultAttrCalcDimName

    public void setDefaultAttrCalcDimName(java.lang.String defAttrCalcDimName)
                                   throws EssException

  Sets the name of the attribute calculations (aggregate) dimension. The default value is "Attribute Calculations". This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Throws:
    `EssException` - if an error occurs.

### getDefaultSumMbrName

    public java.lang.String getDefaultSumMbrName()
                                          throws EssException

  Gets the name used with the attribute calculations (aggregate) dimension to indicate SUM. The default value is "Sum". This is an attribute specification for the outline.

  Returns:
    The name to indicate SUM.
  Throws:
    `EssException` - if an error occurs.

### setDefaultSumMbrName

    public void setDefaultSumMbrName(java.lang.String defSumMbrName)
                              throws EssException

  Sets the name used with the attribute calculations (aggregate) dimension to indicate SUM. The default value is "Sum". This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `defSumMbrName` - The name to indicate SUM.
  Throws:
    `EssException` - if an error occurs.

### getDefaultCountMbrName

    public java.lang.String getDefaultCountMbrName()
                                            throws EssException

  Gets the name used with the attribute calculations (aggregate) dimension to indicate COUNT. The default value is "Count". This is an attribute specification for the outline.

  Returns:
    The name to indicate COUNT.
  Throws:
    `EssException` - if an error occurs.

### setDefaultCountMbrName

    public void setDefaultCountMbrName(java.lang.String defCountMbrName)
                                throws EssException

  Sets the name used with the attribute calculations (aggregate) dimension to indicate COUNT. The default value is "Count". This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `defCountMbrName` - The name to indicate COUNT.
  Throws:
    `EssException` - if an error occurs.

### getDefaultAverageMbrName

    public java.lang.String getDefaultAverageMbrName()
                                              throws EssException

  Gets the name used with the attribute calculations (aggregate) dimension to indicate AVERAGE. The default value is "Average". This is an attribute specification for the outline.

  Returns:
    The name to indicate AVERAGE.
  Throws:
    `EssException` - if an error occurs.

### setDefaultAverageMbrName

    public void setDefaultAverageMbrName(java.lang.String defAverageMbrName)
                                  throws EssException

  Sets the name used with the attribute calculations (aggregate) dimension to indicate AVERAGE. The default value is "Average". This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Throws:
    `EssException` - if an error occurs.

### getDefaultMinMbrName

    public java.lang.String getDefaultMinMbrName()
                                          throws EssException

  Gets the name used with the attribute calculations (aggregate) dimension to indicate MINIMUM. The default value is "Min". This is an attribute specification for the outline.

  Returns:
    The name to indicate MINIMUM.
  Throws:
    `EssException` - if an error occurs.

### setDefaultMinMbrName

    public void setDefaultMinMbrName(java.lang.String defMinMbrName)
                              throws EssException

  Sets the name used with the attribute calculations (aggregate) dimension to indicate MINIMUM. The default value is "Min". This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `defMinMbrName` - The name to indicate MINIMUM.
  Throws:
    `EssException` - if an error occurs.

### getDefaultMaxMbrName

    public java.lang.String getDefaultMaxMbrName()
                                          throws EssException

  Gets the name used with the attribute calculations (aggregate) dimension to indicate MAXIMUM. The default value is "Max". This is an attribute specification for the outline.

  Returns:
    The name to indicate MAXIMUM.
  Throws:
    `EssException` - if an error occurs.

### setDefaultMaxMbrName

    public void setDefaultMaxMbrName(java.lang.String defMaxMbrName)
                              throws EssException

  Sets the name used with the attribute calculations (aggregate) dimension to indicate MAXIMUM. The default value is "Max". This is an attribute specification for the outline. The change will become effective after you invoke updatePropertyValues().

  Parameters:
    `defMaxMbrName` - The name to indicate MAXIMUM.
  Throws:
    `EssException` - if an error occurs.

### refreshPropertyValues

    public void refreshPropertyValues()
                               throws EssException

  Refreshes the property values. The JAPI cache for this object is refreshed with the latest values from the server, so that all the getXXX() methods will return the latest values.

  Specified by:
    `refreshPropertyValues` in interface `IEssProperties`
  Throws:
    `EssException` - if an error occurs.

### updatePropertyValues

    public void updatePropertyValues()
                              throws EssException

  Updates the property values. The changes made to this object via setXXX() methods will become effective only after you invoke updatePropertyValues().

  Specified by:
    `updatePropertyValues` in interface `IEssProperties`
  Throws:
    `EssException` - if an error occurs.

### open

    public void open()
              throws EssException

  Opens the cube outline in read-only mode.

  Throws:
    `EssException` - if an error occurs.

### open

    public void open(boolean readOnly,
                     boolean lock,
                     boolean keepTrans)
              throws EssException

  Opens the cube outline in read-only or read-write mode.

  Parameters:
    `readOnly` - true to open the outline in read-only mode. false to open the outline in read-write mode.
    `lock` - true if the outline should be locked when it is opened in any mode.
    `keepTrans` - true to keep transactions. If you are opening an existing outline to make changes (readOnly == false), and you intend to restructure the cube and keep data, we recommend that you set this flag to true. When true, a log is kept of activities done to the outline. If you are starting from an empty outline or are not planning on saving data when you restructure, we recommend that you set this field to false. When false, no log is kept, saving time and memory.
  Throws:
    `EssException` - if an error occurs.

### isOpen

    public boolean isOpen()
                   throws EssException

  Checks if the outline is open.

  Returns:
    true if the outline is open.
  Throws:
    `EssException` - if an error occurs.

### create

    public void create(boolean caseSensitive,
                       IEssCube.EEssCubeType outlineType,
                       boolean autoConfigure)
                throws EssException

  Creates a new outline.

  Parameters:
    `caseSensitive` - true for case-sensitive member names.
    `outlineType` - The Outline type.
    `autoConfigure` - true to automatically configure the dimension. storage (dense/sparse) when the outline is saved.
  Throws:
    `EssException` - is an error occurs.

### close

    public void close()
               throws EssException

  Closes the outline freeing all resources associated with the outline. This method internally invokes close(false). Once this call is made, make sure not to use the member or dimension objects obtained prior to closing.

  Throws:
    `EssException` - if an error occurs.

### close

    public void close(boolean ignoreErrors)
               throws EssException

  Closes the outline freeing all resources associated with the outline. Once this call is made, make sure not to use the member or dimension objects obtained prior to closing.

  Parameters:
    `ignoreErrors` - true to ignore errors if any and close the outline, false to throw exception in case of errors and not close the outline.
  Throws:
    `EssException` - if an error occurs.

### save

    public void save()
              throws EssException

  Writes the existing outline information to disk.

  Throws:
    `EssException` - if an error occurs.

### save

    public void save(IEssCube.EEssRestructureOption restructOption)
              throws EssException

  Performs 3 operations in one shot: 1. Verifies the outline, 2. Writes the outline information to disk if verification (step-1) is successful, 3. Restructures the cube if writing (step-2) is successful.

  Parameters:
    `restructOption` - The restructure option.
  Throws:
    `EssException` - if an error occurs.

### getUpdateTime

    public java.util.Date getUpdateTime()
                                 throws EssException

  Gets a timestamp for this outline. The returned value for time is not persistent; that is, the value for time is reset whenever the server loads the cube.

  Returns:
    The timestamp.
  Throws:
    `EssException` - if an error occurs.

### verify

    public void verify()
                throws EssException

  Verifies the outline for correctness.

  Throws:
    `EssException` - if an error occurs.

### createDimension

    public IEssDimension createDimension(java.lang.String dimName)
                                  throws EssException

  Creates a dimension.

  Parameters:
    `dimName` - The dimension name.
  Returns:
    The dimension.
  Throws:
    `EssException` - if an error occurs.

### createDimension

    public IEssDimension createDimension(java.lang.String dimName,
                                         IEssDimension prevSibling)
                                  throws EssException

  Creates a dimension.

  Parameters:
    `dimName` - The dimension name.
    `prevSibling` - The previous sibling dimension. The new dimension will be placed after this dimension.
  Returns:
    The dimension.
  Throws:
    `EssException` - if an error occurs.

### createAttributeDimension

    public IEssDimension createAttributeDimension(java.lang.String dimName,
                                                  IEssDimension.EEssAttributeDataType attrDataType,
                                                  IEssDimension prevSibling)
                                           throws EssException

  Creates an attribute dimension.

  Parameters:
    `dimName` - The attribute dimension name.
    `attrDataType` - The attribute dimension data type.
    `prevSibling` - The previous sibling dimension. The new dimension will be placed after this dimension.
  Returns:
    The dimension.
  Throws:
    `EssException` - if an error occurs.

### getDimensions

    public IEssIterator getDimensions()
                               throws EssException

  Gets the list of dimensions.

  Returns:
    The list of dimensions (each of type IEssDimension).
  Throws:
    `EssException` - if an error occurs.

### moveMember

    public void moveMember(IEssMember mbrToMove,
                           IEssMember newParent,
                           IEssMember newPrevSibling)
                    throws EssException

  Moves a member.

  Parameters:
    `mbrToMove` - The member to move
    `newParent` - The new parent. Use this field only if the newPrevSibling field is null.
    `newPrevSibling` - The new previous sibling.
  Throws:
    `EssException` - if an error occurs.

### findMember

    public IEssMember findMember(java.lang.String mbrName)
                          throws EssException

  Finds a member. This method is a wrapper on top of findMembers(), and to fetch multiple members in one round trip use findMembers() instead of this method.

  Parameters:
    `mbrName` - The member name to find.
  Returns:
    The member.
  Throws:
    `EssException` - if an error occurs. If the member is not found, the error code is set to ERROR_OBJECT_NOT_FOUND.

### findMembers

    public IEssIterator findMembers(java.lang.String[] mbrNames)
                             throws EssException

  Finds members. If some of the specified members are not found, there will not be any exception, and the iterator returned will not contain those members.

  Returns:
    The members that are found (each of type IEssMember).
  Throws:
    `EssException` - if an error occurs. If the member is not found, the error code is set to ERROR_OBJECT_NOT_FOUND.

### findDimension

    public IEssDimension findDimension(java.lang.String mbrName)
                                throws EssException

  Finds a dimension for the member.

  Parameters:
    `mbrName` - The member name.
  Returns:
    The dimension.
  Throws:
    `EssException` - if an error occurs. If the dimension is not found, the error code is set to ERROR_OBJECT_NOT_FOUND.

### restructureCube

    public void restructureCube(IEssCube.EEssRestructureOption restructOption)
                         throws EssException

  Restructures the cube based on the newly saved outline.

  Parameters:
    `restructOption` - The restructure option.
  Throws:
    `EssException` - if an error occurs.

### createAliasTable

    public void createAliasTable(java.lang.String aliasTableName)
                          throws EssException

  Creates an empty alias table in the outline.

  Parameters:
    `aliasTableName` - The name of alias table to create.
  Throws:
    `EssException` - if an error occurs.

### copyAliasTable

    public void copyAliasTable(java.lang.String srcAliasTableName,
                               java.lang.String destAliasTableName,
                               boolean merge)
                        throws EssException

  Copies an alias table to another alias table.

  Parameters:
    `srcAliasTableName` - The name of alias table to copy from. If this parameter is null, the default alias table is used.
    `destAliasTableName` - The name of alias table to copy to. Cannot be the same as srcAliasTableName.
    `merge` - true to merge the source file into the existing destination alias table. false to clear the destination alias table before copying.
  Throws:
    `EssException` - if an error occurs.

### renameAliasTable

    public void renameAliasTable(java.lang.String aliasTableName,
                                 java.lang.String newAliasTableName)
                          throws EssException

  Renames an existing alias table

  Parameters:
    `aliasTableName` - The name of alias table to rename.
    `newAliasTableName` - The new name for alias table.
  Throws:
    `EssException` - if an error occurs.

### clearAliasTable

    public void clearAliasTable(java.lang.String aliasTableName)
                         throws EssException

  Clears all entries from an existing alias table without deleting the alias table

  Parameters:
    `aliasTableName` - The name of alias table to clear. Use null or "Default" for the default table.
  Throws:
    `EssException` - if an error occurs.

### deleteAliasTable

    public void deleteAliasTable(java.lang.String aliasTableName)
                          throws EssException

  Deletes the alias table from the outline and clears all of its entries.

  Parameters:
    `aliasTableName` - The name of alias table to delete.
  Throws:
    `EssException` - if an error occurs.

### findAlias

    public IEssMember findAlias(java.lang.String aliasName,
                                java.lang.String aliasTableName)
                         throws EssException

  Finds a member for the alias name.

  Parameters:
    `aliasName` - The alias name to find member for.
    `aliasTableName` - The alias table name which provides the alias.
  Returns:
    The member.
  Throws:
    `EssException` - if an error occurs. If the member is not found, the error code is set to ERROR_OBJECT_NOT_FOUND.

### getDTSMemberAlias

    public java.lang.String getDTSMemberAlias(java.lang.String dtsMemberName,
                                              java.lang.String aliasTableName)
                                       throws EssException

  Gets an alias name for a Dynamic Time Series member.

  Parameters:
    `dtsMemberName` - The DTS member name which provides the alias.
    `aliasTableName` - The alias table name which provides the alias. If null, the default alias table is used
  Returns:
    The alias name for the DTS member.
  Throws:
    `EssException` - if an error occurs.

### setDTSMemberAlias

    public void setDTSMemberAlias(java.lang.String dtsMemberName,
                                  java.lang.String aliasTableName,
                                  java.lang.String alias)
                           throws EssException

  Sets an alias name for a Dynamic Time Series member.

  Parameters:
    `dtsMemberName` - The DTS member name which provides the alias.
    `aliasTableName` - The alias table name which provides the alias. If null, the default alias table is used
    `alias` - The alias name for the DTS member.
  Throws:
    `EssException` - if an error occurs.

### deleteDTSMemberAlias

    public void deleteDTSMemberAlias(java.lang.String dtsMemberName,
                                     java.lang.String aliasTableName)
                              throws EssException

  Deletes an alias name for a Dynamic Time Series member.

  Parameters:
    `dtsMemberName` - The name of the DTS member which provides the alias.
    `aliasTableName` - The name of the alias table which provides the alias. If null, use the default alias table.
  Throws:
    `EssException` - if an error occurs.

### enableDTSMember

    public void enableDTSMember(java.lang.String dtsMemberName,
                                int genNum,
                                boolean enable)
                         throws EssException

  Enables a new Dynamic Time Series members for the outline.

  Parameters:
    `dtsMemberName` - The name of the DTS member.
    `genNum` - The generation to assign to the DTS member.
    `enable` - true to enable the DTS member.
  Throws:
    `EssException` - if an error occurs.

### getCountEnabledDTSMembers

    public int getCountEnabledDTSMembers()
                                  throws EssException

  Gets the count of defined DTS members for the outline.

  Returns:
    The count of defined DTS members.
  Throws:
    `EssException` - if an error occurs.

### getEnabledDTSMember

    public java.lang.String getEnabledDTSMember(int index)
                                         throws EssException

  Gets the defined DTS member name for the outline at the specified index.

  Parameters:
    `index` - The index where to get the DTS member from. This should be between 0 and the value returned by getCountEnabledDTSMembers().
  Returns:
    The DTS member name.
  Throws:
    `EssException` - if an error occurs.

### getGenerationForEnabledDTSMember

    public int getGenerationForEnabledDTSMember(int index)
                                         throws EssException

  Gets the generation for the defined DTS member name for the outline at the specified index.

  Parameters:
    `index` - The index where to get the DTS member from. This should be between 0 and the value returned by getCountEnabledDTSMembers().
  Returns:
    The generation number.
  Throws:
    `EssException` - if an error occurs.

### generateCurrencyOutline

    public IEssCubeOutline generateCurrencyOutline()
                                            throws EssException

  Generates a currency outline based on the current (source) outline. The source outline must have a Time, Accounts, and Country dimension. Time dimension and all descendants are copied directly from the source outline to a Time dimension in the new outline. A dimension named CurCategory (Dense, Category = Accounts) is created in the new outline. All currency categories in the source Accounts dimension become children of the CurCategory dimension in the new outline. A dimension named CurName (Dense, Category = Country) is created in the new outline. All currency names from the source Country dimension become children of the CurName dimension in the new outline. A dimension named CurType (Sparse, Category = Type) is created with no children in the new outline. The currency outline must be saved by calling save() followed by restructure() and closed by calling close(). The new outline has the following attributes: Auto-configure is set to ESS_TRUE, Case-sensitivity is the same as the original outline.

  Returns:
    The currency outline.
  Throws:
    `EssException` - if an error occurs.

### associateAttributeDimension

    public void associateAttributeDimension(IEssDimension standardDim,
                                            IEssDimension attributeDim)
                                     throws EssException

  Associates an attribute dimension with a base dimension.

  Parameters:
    `standardDim` - The standard or base dimension.
    `attributeDim` - The attribute dimension.
  Throws:
    `EssException` - if an error occurs.

### disassociateAttributeDimension

    public void disassociateAttributeDimension(IEssDimension standardDim,
                                               IEssDimension attributeDim)
                                        throws EssException

  Disassociates an attribute dimension from a base dimension.

  Parameters:
    `standardDim` - The standard or base dimension.
    `attributeDim` - The attribute dimension.
  Throws:
    `EssException` - if an error occurs.

### associateAttributeMember

    public void associateAttributeMember(IEssMember standardMbr,
                                         IEssMember attributeMbr)
                                  throws EssException

  Associates an attribute member with a base member.

  Parameters:
    `standardMbr` - The standard or base member.
    `attributeMbr` - The attribute member.
  Throws:
    `EssException` - if an error occurs.

### associateAttributeMember

    public void associateAttributeMember(java.lang.String standardMbrName,
                                         java.lang.String attributeMbrName)
                                  throws EssException

  Associates an attribute member with a base member.

  Parameters:
    `standardMbrName` - The standard or base member name.
    `attributeMbrName` - The attribute member name.
  Throws:
    `EssException` - if an error occurs.

### disassociateAttributeMember

    public void disassociateAttributeMember(IEssMember standardMbr,
                                            IEssMember attributeMbr)
                                     throws EssException

  Disassociates an attribute member from a base member

  Parameters:
    `standardMbr` - The standard or base member.
    `attributeMbr` - The attribute member.
  Throws:
    `EssException` - if an error occurs.

### findAttributeMembers

    public IEssIterator findAttributeMembers(java.lang.String attShortName,
                                             java.lang.String dimName)
                                      throws EssException

  Gets all the attribute members having the specified short name.

  Parameters:
    `attShortName` - The attribute short name (A zero-level attribute member that is not of type ESS_ATTRMBRDT_STRING is called a short name).
    `dimName` - The attribute dimension name. "" can also be passed.
  Returns:
    The list of base members (each of type IEssMember).
  Throws:
    `EssException` - if an error occurs.

### getSharedMembers

    public IEssIterator getSharedMembers(java.lang.String mbrName)
                                  throws EssException

  Gets all the shared members of the specified member.

  Returns:
    The shared members.
  Throws:
    `EssException` - if an error occurs.

### executeQuery

    public IEssIterator executeQuery(java.lang.String mbrName,
                                     int queryType,
                                     int queryOptions,
                                     java.lang.String dimName,
                                     java.lang.String input1,
                                     java.lang.String input2)
                              throws EssException

  Member selection over outline. Refer to IEssMemberSelection.executeQuery for more description.

  Throws:
    `EssException` - if an error occurs.

### executeQuery

    public IEssIterator executeQuery(java.lang.String fieldSelection,
                                     java.lang.String mbrSelection)
                              throws EssException

  Member selection over outline. Refer to IEssMemberSelection.executeQuery for more description.

  Throws:
    `EssException` - if an error occurs.

### getCube

    public IEssCube getCube()
                     throws EssException

  Gets the parent cube.

  Returns:
    The cube.
  Throws:
    `EssException` - if an error occurs.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD